<?php
/**************************************************
  Coppermine 1.5.x Plugin - EasyRotate
  *************************************************
  Copyright (c) 2010 S.J.Hoeksma
  *************************************************
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  **************************************************/

if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

// Add an install action
$thisplugin->add_action('plugin_install', 'easyrotate_install');

// Add a configure action
$thisplugin->add_action('plugin_configure', 'easyrotate_configure');

// Add an uninstall action
$thisplugin->add_action('plugin_uninstall','easyrotate_uninstall');

// Add a acction to page start, handling custom actions
$thisplugin->add_action('page_start', 'easyrotate_page_start');

// Add a filter for displaying the on display image page
$thisplugin->add_filter('file_data', 'easyrotate_file_data');

// Add a filter for url manipulation, adding cache_id
$thisplugin->add_filter('picture_url','easyrotate_picture_url');


global $easyrotate_configs;
$easyrotate_configs = array('easyrotate_confirm','easyrotate_cache_id','easyrotate_hide_delete');

// Install function
// Inserts the config variables in cpg_config table
function easyrotate_install() {
    global $CONFIG, $easyrotate_configs;
    $superCage   = Inspekt::makeSuperCage();
    // Install
    if ($superCage->post->keyExists('easyrotate_confirm') && trim($superCage->post->getEscaped('easyrotate_confirm'))) {
        foreach ($easyrotate_configs as $config_name) {
            $config_value = trim($superCage->post->getEscaped($config_name));
            // Run the query to put a config variable for convert path            
            if ($config_value) {
                $query = "REPLACE INTO {$CONFIG['TABLE_CONFIG']} SET name = '$config_name', value = '$config_value'";
                cpg_db_query($query);
            }            
        }

        return true;

    // Loop again
    } else {
        return 1;
    }
}

// Configure function
// Displays the form
function easyrotate_configure() {
    global $CONFIG;
    
        
    if (!isset($CONFIG['easyrotate_confirm']) || $CONFIG['easyrotate_confirm'] == 'no') {
      $confirm_no = ' checked="checked"';
    } else {
      $confirm_yes = ' checked="checked"';
    }

    if (!isset($CONFIG['easyrotate_cache_id']) || $CONFIG['easyrotate_cache_id'] == 'yes') {
      $cache_id_yes = ' checked="checked"';
    } else {
      $cache_id_no = ' checked="checked"';
    }

    if (!isset($CONFIG['easyrotate_hide_delete']) || $CONFIG['easyrotate_hide_delete'] == 'yes') {
      $delete_yes = ' checked="checked"';
    } else {
      $delete_no = ' checked="checked"';
    }

    echo <<< EOT
    <form name="cpgform" id="cpgform" action="{$_SERVER['REQUEST_URI']}" method="post">
            <table border="0" cellspacing="0" cellpadding="0" width="100%">
              <tr>
                <td class="tableb" align="right" width="250">
                  Confirm delete of photos :
                </td>
                <td class="tableb">
                  <input type="radio" id="confirm_yes" name="easyrotate_confirm" class="radio" {$confirm_yes} value="yes"/>
                  <label for="confirm_yes">Yes</label>
                  &nbsp;&nbsp;
                  <input type="radio" id="confirm_no" name="easyrotate_confirm" class="radio" value="no" {$confirm_no} />
                  <label for="confirm_no">No</label>
                </td>
              </tr>
               <tr>
								<td class="tableb" align="right" width="250">
									Hide orginal delete button:
								</td>
								<td class="tableb">
									<input type="radio" id="delete_yes" name="easyrotate_hide_delete" class="radio" {$delete_yes} value="yes"/>
									<label for="delete_yes">Yes</label>
									&nbsp;&nbsp;
									<input type="radio" id="delete_no" name="easyrotate_hide_delete" class="radio" value="no" {$delete_no} />
									<label for="delete_no">No</label>
								</td>
              </tr>
              <tr>
                <td class="tableb" align="right" width="250">
                  Add update timestamp to photo url as work arround for caching issue:
                </td>
                <td class="tableb">
                  <input type="radio" id="cache_id_yes" name="easyrotate_cache_id" class="radio" {$cache_id_yes} value="yes"/>
                  <label for="cache_id_yes">Yes</label>
                  &nbsp;&nbsp;
                  <input type="radio" id="cache_id_no" name="easyrotate_cache_id" class="radio" value="no" {$cache_id_no} />
                  <label for="cache_id_no">No</label>
                </td>
              </tr>
              <tr>
                <td class="tablef" colspan="2">
                  <input type="submit" value="Go!" class="button" />
                </td>
              </tr>
            </table>
    </form>
EOT;
}

/**
 * Function called when the plugin is uninstalled
 * 
 * We will delete the plugin related config values from db
 */
function easyrotate_uninstall() {
    global $CONFIG, $easyrotate_configs;
    // Delete the plugin related config values
    if (isset($CONFIG['easyrotate_cache_id']) && $CONFIG['easyrotate_cache_id']!='') {
		    $query = "REPLACE INTO {$CONFIG['TABLE_CONFIG']} SET name = 'user_field" . $CONFIG['easyrotate_cache_id'] ."_name', value = ''";
				@cpg_db_query($query);            
		}
    foreach ($easyrotate_configs as $name) {
        $f = cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE `name` = '$name'");
    }
    return true;
}



function easyrotate_rotate($CURRENT_PIC,$angle){
    global $CONFIG;
	//Include the proper class for image Object
	require_once('include/picmgmt.inc.php');
	if ($CONFIG['thumb_method']=="gd2"){
			require_once("include/imageobject_gd.class.php");
	}elseif ($CONFIG['thumb_method']=="im"){
			require_once("include/imageobject_im.class.php");
	}else{
			//die ($lang_editpics_php['error_editor_class']);
	}

   $img_dir =  $CONFIG['fullpath'].'edit/';

	 //Copy the Image file to the editing directory
	 if (copy($CONFIG['fullpath'].$CURRENT_PIC['filepath'].$CURRENT_PIC['filename'],$img_dir.$CURRENT_PIC['filename'])) {
	    $newimage = $CURRENT_PIC['filename'];
	    if ($newimage){
	  		if($angle < 0) $angle = 360 + $angle;
			$imgObj = new imageObject($img_dir,$newimage);
	  		$imgObj->quality = $CONFIG['jpeg_qual'];
	  		$imgObj = $imgObj->rotateImage($angle);
	  		$newimage = $imgObj->filename;
        $width=$imgObj->width;
        $height=$imgObj->height;
        $normal = $CONFIG['fullpath'] . $CURRENT_PIC['filepath'] . $CONFIG['normal_pfx'] . $CURRENT_PIC['filename'];
        $thumbnail = $CONFIG['fullpath'] . $CURRENT_PIC['filepath'] . $CONFIG['thumb_pfx'] . $CURRENT_PIC['filename'];
        $filesize = @filesize($img_dir.$newimage);

        //Full image replace
        copy($img_dir.$newimage,$CONFIG['fullpath'].$CURRENT_PIC['filepath'].$CURRENT_PIC['filename'])   ;

        // Normal image resized and replace, use the CPG resize method instead of the object resizeImage
        // as using the object resizeImage will make the final display of image to be a thumbnail in the editor

        if (max($width, $height) > $CONFIG['picture_width'] && $CONFIG['make_intermediate']) {
            resize_image($img_dir.$newimage, $normal, $CONFIG['picture_width'], $CONFIG['thumb_method'], $CONFIG['thumb_use']);
        } else {
            @unlink($normal);
        }

        //thumbnail resized and replace
        resize_image($img_dir.$newimage, $thumbnail, $CONFIG['thumb_width'], $CONFIG['thumb_method'], $CONFIG['thumb_use']);
        $total_filesize = $filesize + (file_exists($normal) ? filesize($normal) : 0) + filesize($thumbnail);
                
        //Update the image size in the DB
        cpg_db_query("UPDATE {$CONFIG['TABLE_PICTURES']}
                      SET pheight = $height,
                          pwidth = $width,
                          filesize = $filesize,
                          total_filesize = $total_filesize
                      WHERE pid = '{$CURRENT_PIC['pid']}'");
        
        //Remove the temp file
        @unlink($img_dir.$newimage);     
     }
  }

}

function easyrotate_page_start() {
    global $CONFIG, $lang_errors;
    $superCage = Inspekt::makeSuperCage();

    if ($superCage->get->keyExists('easyrotate_id')) {
        $pid = $superCage->get->getInt('easyrotate_id');
        $result = cpg_db_query("SELECT * FROM {$CONFIG['TABLE_PICTURES']} AS p INNER JOIN {$CONFIG['TABLE_ALBUMS']} AS a ON a.aid = p.aid WHERE p.pid = '$pid' LIMIT 1");
        $pic = mysql_fetch_assoc($result);
        mysql_free_result($result);


        if (!((USER_ADMIN_MODE && $pic['category'] == FIRST_USER_CAT + USER_ID) || ($CONFIG['users_can_edit_pics'] && $pic['owner_id'] == USER_ID && USER_ID != 0) || GALLERY_ADMIN_MODE)) {
            load_template();
            cpg_die(ERROR, $lang_errors['access_denied'], __FILE__, __LINE__);
        }

        
        if ($superCage->get->keyExists('easyrotate_action') && $pic) {
          $action = $superCage->get->getInt('easyrotate_action');
          if (($action==-1) || ($action==1)) { // Rotate -90 or 90
            easyrotate_rotate($pic,90*$action);
          } elseif ($action==99) { //Delete of image to perfom
            cpg_db_query("DELETE FROM {$CONFIG['TABLE_COMMENTS']} WHERE pid = $pid");
						$dir = $CONFIG['fullpath'].$pic['filepath'];
						$file = $pic['filename'];
						if (!is_writable($dir)) {
								cpg_die(CRITICAL_ERROR, sprintf($lang_errors['directory_ro'], $dir), __FILE__, __LINE__);
						}
            $files = array($dir . $file, $dir . $CONFIG['normal_pfx'] . $file, $dir . $CONFIG['orig_pfx'] . $file, $dir . $CONFIG['thumb_pfx'] . $file);					
						// Check for custom thumbnails for non-images
						if (!is_image($file)) {
								$mime_content = cpg_get_type($file);
								$file_base_name = str_replace('.' . $mime_content['extension'], '', basename($file));

								foreach (array('.gif','.png','.jpg') as $thumb_extension) {
										if (file_exists($dir . $CONFIG['thumb_pfx'] . $file_base_name . $thumb_extension)) {
												// Thumbnail found, check if it's the only file using that thumbnail
												$count = mysql_result(cpg_db_query("SELECT COUNT(*) FROM {$CONFIG['TABLE_PICTURES']} WHERE filepath = '{$pic['filepath']}' AND filename LIKE '{$file_base_name}.%'"), 0);
												if ($count == 1) {
														unset($files[count($files)-1]);
														$files[] = $dir . $CONFIG['thumb_pfx'] . $file_base_name . $thumb_extension;
														break;
												}
										}
								}
						}
						foreach ($files as $currFile) {
								if (is_file($currFile)) {
										@unlink($currFile);
								}
						}
						// Plugin filter to be called before deleting a file
						CPGPluginAPI::action('before_delete_file', $pic);
						cpg_db_query("DELETE FROM {$CONFIG['TABLE_PICTURES']} WHERE pid = $pid");
						// Plugin filter to be called after a file is deleted
						CPGPluginAPI::action('after_delete_file', $pic);
						
						//Todo: Find the next id to display
						$pid=$superCage->get->getInt('easyrotate_next');; 
 					}
      }
      //Redirect to page
      header("Location: {$CONFIG['site_url']}displayimage.php?pid=$pid");
			exit();
    }
}


/**
 * Function to return html required for displaying the normal image
 */
function easyrotate_file_data($data) {
    global $CONFIG, $CURRENT_ALBUM_DATA;

    if ((USER_ADMIN_MODE && $CURRENT_ALBUM_DATA['category'] == FIRST_USER_CAT + USER_ID) || ($CONFIG['users_can_edit_pics'] && $data['owner_id'] == USER_ID && USER_ID != 0) || GALLERY_ADMIN_MODE) {
				  //Check if we should remove the default delete button
        if ($CONFIG['easyrotate_hide_delete'] == 'yes') {
        	$pos=strripos($data['menu'],'delete.php');
					if (!($pos === false)) {
						$pos=strripos(substr($data['menu'],0,$pos),'<li>');
						$data['menu'] = substr($data['menu'],0,$pos-1)  . substr($data['menu'],stripos($data['menu'],'</li>',$pos)+5);
					}        
			  }		
				 // attempt to determine the position directly
				$picpos = get_pic_pos($data['aid'], $data['pid']);
				$album_name=$data['title'];
				$album=$data['aid'];
				$pid=$data['pid'];
				if ($picpos === FALSE) {					    
					 $pic_data = get_pic_data($album, $pic_count, $album_name, -1, -1, false);					        
					 for ($picpos = 0; $pic_data[$picpos]['pid'] != $pid && $picpos < $pic_count; $picpos++);
				}					   
				$picnext = get_pic_data($album, $pic_count, $album_name, ($picpos+1<$pic_count ? $picpos + 1 : $picpos-1) , 1, false, 'pidonly');
				$picnext = $picnext[0]['pid'];        
				//Add the new delete button
				$menu_icon = ($CONFIG['enable_menu_icons'] > 0) ? '<img src="images/icons/delete.png" border="0" width="16" height="16" class="icon" /> ' : '';
				$confirm = $CONFIG['easyrotate_confirm'] == 'no' ? "" : "onclick=\"return confirm('Are you sure you want to DELETE this file ? \\nComments will also be deleted.'); return false;\"";
				$menu_button .= "<li><a href=\"displayimage.php?easyrotate_id={$data['pid']}&easyrotate_action=99&easyrotate_next=$picnext\" $confirm ><span>{$menu_icon}delete</span></a></li>";        

				//Only add rotate buttons for images
				$filepath = $data['filepath'];
				$filename = $data['filename'];
				$image = $CONFIG['fullpath'] . $filepath . $filename;
        if (is_image($image)) {
          $menu_icon = ($CONFIG['enable_menu_icons'] > 0) ? '<img src="images/icons/rotate_cw.png" border="0" width="16" height="16" class="icon" /> ' : '';
          $menu_button .= "<li><a href=\"displayimage.php?easyrotate_id={$data['pid']}&easyrotate_action=1\" ><span>{$menu_icon}-90&#176;</span></a></li>";
          $menu_icon = ($CONFIG['enable_menu_icons'] > 0) ? '<img src="images/icons/rotate_ccw.png" border="0" width="16" height="16" class="icon" /> ' : '';
		  $menu_button .= "<li><a href=\"displayimage.php?easyrotate_id={$data['pid']}&easyrotate_action=-1\"><span>{$menu_icon}+90&#176;</span></a></li>";        
				}
				$data['menu'] = str_replace('</ul>', $menu_button.'</ul>', $data['menu']);
   }
    return $data;
}
/**
 * This function will add unique cache id to a picture, so it is reloaded when we rotate it
 */
function easyrotate_picture_url($pic){
    global $CONFIG;
    if (is_image($pic['filename']) && $CONFIG['easyrotate_cache_id']!='no') 
       $pic['url'] .= (strrpos($pic['url'],'?') === false ? '?' : '&' ) . 'easyrotate_cache=' . filemtime($CONFIG['fullpath'] . $pic['filepath'] . $pic['filename']);
    
    return $pic;
}

?>